#include "commun.h"

int objetsUtilises, posX, posY, scrlX, scrlY;
TypeSprite MonOAM[128];

void ReinitSprites()        {
    objetsUtilises=0;
    memset(MonOAM,0,sizeof(MonOAM));
}

//Cre un nouvel objet
#define CreeObjet(obj_number,char_number,xpos,ypos,obj_mode,obj_shape,obj_size,color_mode,pal_number,prio_to_bg,vflip,hflip,mosaic,rotation,rotation_no,dblsize) \
                        \
                        MonOAM[obj_number].attribut0= \
                        (obj_shape<<14)  | \
                        (color_mode<<13) | \
                        (mosaic<<12)     | \
                        (obj_mode<<10)   | \
                        (rotation<<8)    | \
                        (dblsize<<9)     | \
                        (ypos); \
                        \
                        MonOAM[obj_number].attribut1= \
                        (obj_size<<14)   |\
                        (vflip<<13)      |\
                        (hflip<<12)      |\
                        (rotation_no<<9) |\
                        (xpos);\
                        \
                        MonOAM[obj_number].attribut2= \
                        (pal_number<<12) |\
                        (prio_to_bg<<10) |\
                        (char_number);


#define CodeBaseCreeObjet   if (objetsUtilises>=127)    \
                                return 0;                                               \
                            VerifieSIlYABesoinDePlacerUnSprite(x,y);                    \
                            if (posX==240 || posY==160)                                 \
                                return 0;                                               \
                            objetsUtilises++;

void VerifieSIlYABesoinDePlacerUnSprite(u32 x, u32 y)     {
    s32 i,j;
    i=x-scrlX;
    if (i>240)
        i=240;
    if (i<0 && i>-64)
        i=512+i;
    j=y-scrlY;
    if (j>160)
        j=160;
    if (j<0 && j>-64)
        j=256+j;
    if (i<0)
        i=240;
    if (j<0)
        j=160;
    posX=i;
    posY=j;
}

//Retourne 1 si l'objet existe, 0 sinon
u32  CreeObjetStandard(u16 x, u16 y, unsigned short tiles, unsigned short palette, unsigned short forme, unsigned short taille)        {
    CodeBaseCreeObjet;
    //Cration de Mario
    CreeObjet(objetsUtilises,  //Numro d'objet
    tiles,                  //Numro de mosaque (3), <<2 car 16x16 (*4) et <<1 car mode 8 bits (*2)
    posX,                    //Position X initiale
    posY,                    //Position Y initiale
    0,                      //Mode (alpha-blend)
    forme,                  //Forme (0=carre)
    taille,                 //Taille
    0,                      //Mode palette (1=256 couleurs, 0=16 couleurs)
    palette,                //Numro de palette si 16 couleurs
    2,                      //Priorit
    0,                      //Retournement vertical
    0,                      //Retournement horizontal
    0,                      //Mode mosaque (?)
    0,                      //Rotation
    0,                      //N de rotation
    0);                     //Double-taille (pour rotation)
    return 1;
}

